#ifndef _BUFFER_H_
#define _BUFFER_H_

class CBuffer : public CObject
{
public:
  CBuffer (size_t Size = 1024);
  virtual ~CBuffer();

  void Reset();

  int PutChar (unsigned char Char);
  int GetChar (unsigned char* pChar);
  void Clear();

  CEvent NotEmpty;

protected:
  CCriticalSection Lock;
  unsigned char* pBuf;
  size_t BufSize;
  unsigned int IndexHead;
  unsigned int IndexTail;
};

#endif // _BUFFER_H_
