// UartTest.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "UartTest.h"

#include "UartDrv.h"

#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
  int nRetCode = 0;

  // initialize MFC and print and error on failure
  if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
  {
    // TODO: change error code to suit your needs
    cerr << _T("Fatal Error: MFC initialization failed") << endl;
    nRetCode = 1;
  }
  else
  {
    // TODO: code your application's behavior here.

    CUartDrv UartDrv;
    unsigned char c;
    unsigned int xpos=0;

    COMMCONFIG CommCfg;

    memset (&CommCfg, 0, sizeof(CommCfg));
    CommCfg.dwSize = sizeof(CommCfg);
    CommCfg.dcb.DCBlength = sizeof(CommCfg.dcb);

    CommConfigDialog ("COM1", NULL, &CommCfg);

    UartDrv.OpenPort ("COM1", &CommCfg.dcb);

    while(1)
    {
      if (kbhit())
      {
        c = getch();
        if (c==27)
          break;
        UartDrv.PutChar (c);
      }

      if (UartDrv.GetChar (&c))
      {
        switch (c)
        {
          case 9:
            {
              unsigned int i;
              i = ((xpos + 8) & ~7) - xpos;
              while (i-- > 0)
              {
                printf (" ");
                xpos++;
              }
            }
          break;
          case 10:
          case 13:
            printf ("%c", c);
            xpos=0;
          break;
          default:
            printf ("%c", c);
            xpos++;
        }
      }
    }
  }

  return nRetCode;
}
